searchNodes=[{"type":"module","title":"TestIex","doc":"Allows running test files by substring of their names","ref":"TestIex.html"},{"type":"function","title":"TestIex.core_module/0","doc":"","ref":"TestIex.html#core_module/0"},{"type":"function","title":"TestIex.run/1","doc":"Run all matching test files Examples: iex&gt; TestIex.run(&quot;user&quot;) iex&gt; TestIex.run(&quot;user_test.exs&quot;) iex&gt; TestIex.run(&quot;some_file:12&quot;)","ref":"TestIex.html#run/1"},{"type":"function","title":"TestIex.run/2","doc":"Run the first matching test file with a line selector Examples: # run first matching file for &quot;user&quot; on line 40 iex&gt; TestIex.run(&quot;user&quot;, 40) # same as iex&gt; TestIex.run(&quot;user:40&quot;)","ref":"TestIex.html#run/2"},{"type":"function","title":"TestIex.test_files/0","doc":"","ref":"TestIex.html#test_files/0"},{"type":"function","title":"TestIex.unwatch/0","doc":"Stop watching changes on files","ref":"TestIex.html#unwatch/0"},{"type":"function","title":"TestIex.watch/1","doc":"Set which test files / lines should run on each file change TestIex.Config.test_file_globs() defines which files would trigger a re-run","ref":"TestIex.html#watch/1"},{"type":"function","title":"TestIex.watch/2","doc":"","ref":"TestIex.html#watch/2"},{"type":"module","title":"TestIex.Config","doc":"Central module for all provided configuration options","ref":"TestIex.Config.html"},{"type":"function","title":"TestIex.Config.from_env/2","doc":"","ref":"TestIex.Config.html#from_env/2"},{"type":"function","title":"TestIex.Config.test_file_globs/0","doc":"Which test files should be matched? List of path globs, compatible with Path.wildcard defaults: [ &quot;./test/**/**_test.exs&quot;, &quot;./lib/**/**_test.exs&quot; ]","ref":"TestIex.Config.html#test_file_globs/0"},{"type":"function","title":"TestIex.Config.watcher_args/0","doc":"Watcher args, that are passed directly to :file_system package. https://hexdocs.pm/file_system/readme.html defaults: [dirs: [&quot;lib/&quot;, &quot;test/&quot;], latency: 0]","ref":"TestIex.Config.html#watcher_args/0"},{"type":"function","title":"TestIex.Config.watcher_dedup_timeout/0","doc":"FS events deduplication frame, so that we do not trigger too many test runs on file changes. defaults: 500","ref":"TestIex.Config.html#watcher_dedup_timeout/0"},{"type":"function","title":"TestIex.Config.watcher_enable/0","doc":"Should the watcher be started? defaults: true","ref":"TestIex.Config.html#watcher_enable/0"},{"type":"function","title":"TestIex.Config.watcher_extensions/0","doc":"Which file extentions do we consider relevant for re-running tests? defaults: [&quot;.ex&quot;, &quot;.exs&quot;]","ref":"TestIex.Config.html#watcher_extensions/0"},{"type":"module","title":"TestIex.Core","doc":"A utility module that helps you iterate faster on unit tests. This module lets execute specific tests from within a running iex shell to avoid needing to start and stop the whole application every time.","ref":"TestIex.Core.html"},{"type":"function","title":"TestIex.Core.start/0","doc":"Starts the testing context. Examples iex&gt; TestIex . start ( )","ref":"TestIex.Core.html#start/0"},{"type":"function","title":"TestIex.Core.test/2","doc":"Runs a single test, a test file, or multiple test files Example: Run a single test iex&gt; TestIex . test ( &quot;./path/test/file/test_file_test.exs&quot; , line_number ) Example: Run a single test file iex&gt; TestIex . test ( &quot;./path/test/file/test_file_test.exs&quot; ) Example: Run several test files: iex&gt; TestIex . test ( [ &quot;./path/test/file/test_file_test.exs&quot; , &quot;./path/test/file/test_file_2_test.exs&quot; ] )","ref":"TestIex.Core.html#test/2"},{"type":"module","title":"TestIex.Log","doc":"","ref":"TestIex.Log.html"},{"type":"function","title":"TestIex.Log.colorize/1","doc":"","ref":"TestIex.Log.html#colorize/1"},{"type":"function","title":"TestIex.Log.debug/1","doc":"","ref":"TestIex.Log.html#debug/1"},{"type":"function","title":"TestIex.Log.log_file_and_line/2","doc":"","ref":"TestIex.Log.html#log_file_and_line/2"},{"type":"function","title":"TestIex.Log.log_files/1","doc":"","ref":"TestIex.Log.html#log_files/1"},{"type":"function","title":"TestIex.Log.log_msg/1","doc":"","ref":"TestIex.Log.html#log_msg/1"},{"type":"module","title":"TestIex.Matcher","doc":"File matching logic in a separate module for easier testing","ref":"TestIex.Matcher.html"},{"type":"function","title":"TestIex.Matcher.match/2","doc":"","ref":"TestIex.Matcher.html#match/2"},{"type":"function","title":"TestIex.Matcher.match/3","doc":"","ref":"TestIex.Matcher.html#match/3"},{"type":"module","title":"TestIex.Watcher","doc":"Watcher for file events + evtl. running a configured cmd function","ref":"TestIex.Watcher.html"},{"type":"function","title":"TestIex.Watcher.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"TestIex.Watcher.html#child_spec/1"},{"type":"function","title":"TestIex.Watcher.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"TestIex.Watcher.html#init/1"},{"type":"function","title":"TestIex.Watcher.set_command/1","doc":"","ref":"TestIex.Watcher.html#set_command/1"},{"type":"function","title":"TestIex.Watcher.start_link/1","doc":"","ref":"TestIex.Watcher.html#start_link/1"},{"type":"module","title":"TestIex.Watcher.State","doc":"","ref":"TestIex.Watcher.State.html"},{"type":"extras","title":"README","doc":"TestIex TestIex is an interactive ExUnit test runner, that provides following features: Easy to learn: the public API consists of 3 functions: TestIex.run(matcher // &quot;&quot;) TestIex.run(matcher, line) TestIex.watch(matcher // &quot;&quot;) TestIex.watch(matcher, line) TestIex.unwatch() Rapid feedback: since there is no re-incurring cost of starting an OS process with Elixir + Mix + your code for every run With sensible defaults: you won't have to spend a lot of time to get it configured. Default configs provide great experience for the majority of Elixir projects Usable File event de-duplication during watch mode means you only run tests once, even if there are rapid multiple consecutive file events for a single file Robust it does code recompilation + loading of tests in a predictable manner Flexible: should you have some special needs, there are config options to tune. they are all conveniently kept in a single module TestIex.Config . heck, you could even swap the TestIex.Core module, if desired! It exposes only 3 public functions: start() test(files) test(file, line) Inspectable you can turn on debug logs to see what happens this helps you to narrow down issues with your configuration Support for test file co-location: it comes with support for co-located ExUnit tests out of the box! Examples of real-life projects using co-located test files https://github.com/maxohq/maxo_adapt/blob/main/lib/maxo_adapt_test.exs To configure co-located test you'll need to adjust following files https://github.com/maxohq/maxo_adapt/blob/main/mix.exs (test_paths, test_pattern) create a test helper in lib : https://github.com/maxohq/maxo_adapt/blob/main/lib/test_helper.exs Now you're running! This pattern is very common in Golang / JS / TypeScript and we think it should be also more common in the Elixir community. Low - tech: it does not require a particular editor extension or similar. Just simple Elixir + ExUnit in your terminal. your workflow wont have to change in future, since the foundation for TestIex is very stable: ExUnit + file system watching + Iex Maintainable: since it requires very little code, it's very easy to maintain and adjust on new Elixir releases the core is in TestIex.Core . It is less than 40 lines of Elixir code with lots of docs. besides it does not have any hairy GenServer logic and also has no ambitions to grow more features and become more complex by not supporting umbrella projects, we keep the code complexity much lower every Elixir project is considered to be in a single root folder with following directories under it: lib test Please give it a try and see if you like it!","ref":"readme.html"},{"type":"extras","title":"README - Usage","doc":"$ MIX_ENV = test iex - S mix # Run all tests iex&gt; TestIex . run # Run all matching files iex&gt; TestIex . run ( &quot;word&quot; ) # Run test on line 45 for the first matching file iex&gt; TestIex . run ( &quot;word&quot; , 45 ) # Run test on line 45 for the first matching file iex&gt; TestIex . run ( &quot;users_test.exs:45&quot; ) # Run test on line 45 for the first matching file iex&gt; TestIex . run ( &quot;users:45&quot; ) # Watching on file changes and re-running tests. # Currently only .ex / .exs files in `lib` or `test` folders trigger a re-run. iex&gt; TestIex . watch ( &quot;users:45&quot; ) # Reset watching iex&gt; TestIex . unwatch ( )","ref":"readme.html#usage"},{"type":"extras","title":"README - Configuration","doc":"# in config/runtime.exs import Config if config_env ( ) == :test do # for default values look into: # - https://github.com/maxohq/maxo_test_iex/blob/main/lib/test_iex/config.ex # NO need to watch for tests on CI if System . get_env ( &quot;CI&quot; ) , do : config :maxo_test_iex , watcher_enable : false # how long multiple consecutive events on the same file should be considered duplicates? config :maxo_test_iex , watcher_dedup_timeout : 500 # which file changes should trigger a test re-run? config :maxo_test_iex , watcher_args : [ dirs : [ &quot;lib/&quot; , &quot;test/&quot; ] , latency : 0 ] # which file extensions are relevant to trigger a test re-run? config :maxo_test_iex , watcher_extensions : [ &quot;.ex&quot; , &quot;.exs&quot; ] # should we log debug messages? config :maxo_test_iex , debug : false end","ref":"readme.html#configuration"},{"type":"extras","title":"README - Installation","doc":"def deps do [ { :maxo_test_iex , &quot;~&gt; 0.1&quot; , only : [ :test ] } , ] end","ref":"readme.html#installation"},{"type":"extras","title":"README - Alternatives","doc":"https://hex.pm/packages/test_iex (the core is take from this project and was extended / improved) https://hex.pm/packages/tix https://hex.pm/packages/mix_test_watch https://hex.pm/packages/mix_test_interactive https://github.com/marciol/mix_test_iex https://hex.pm/packages/mr_t","ref":"readme.html#alternatives"},{"type":"extras","title":"README - Support","doc":"","ref":"readme.html#support"},{"type":"extras","title":"README - License","doc":"The lib is available as open source under the terms of the MIT License .","ref":"readme.html#license"}]